'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _bitJson;

function _load_bitJson() {
  return _bitJson = _interopRequireDefault(require('../bit-json'));
}

var _sources;

function _load_sources() {
  return _sources = require('../component/sources');
}

var _consumerBitJson;

function _load_consumerBitJson() {
  return _consumerBitJson = _interopRequireDefault(require('../bit-json/consumer-bit-json'));
}

var _consumer;

function _load_consumer() {
  return _consumer = _interopRequireDefault(require('../consumer'));
}

var _bitId;

function _load_bitId() {
  return _bitId = _interopRequireDefault(require('../../bit-id/bit-id'));
}

var _scope;

function _load_scope() {
  return _scope = _interopRequireDefault(require('../../scope/scope'));
}

var _bitIds;

function _load_bitIds() {
  return _bitIds = _interopRequireDefault(require('../../bit-id/bit-ids'));
}

var _parser;

function _load_parser() {
  return _parser = _interopRequireDefault(require('../../jsdoc/parser'));
}

var _parser2;

function _load_parser2() {
  return _parser2 = require('../../jsdoc/parser');
}

var _specsRunner;

function _load_specsRunner() {
  return _specsRunner = _interopRequireDefault(require('../../specs-runner'));
}

var _specsResults2;

function _load_specsResults() {
  return _specsResults2 = _interopRequireDefault(require('../specs-results'));
}

var _componentSpecsFailed;

function _load_componentSpecsFailed() {
  return _componentSpecsFailed = _interopRequireDefault(require('../exceptions/component-specs-failed'));
}

var _buildException;

function _load_buildException() {
  return _buildException = _interopRequireDefault(require('./exceptions/build-exception'));
}

var _missingFilesFromComponent;

function _load_missingFilesFromComponent() {
  return _missingFilesFromComponent = _interopRequireDefault(require('./exceptions/missing-files-from-component'));
}

var _componentNotFoundInPath;

function _load_componentNotFoundInPath() {
  return _componentNotFoundInPath = _interopRequireDefault(require('./exceptions/component-not-found-in-path'));
}

var _environment;

function _load_environment() {
  return _environment = _interopRequireDefault(require('../../environment'));
}

var _environment2;

function _load_environment2() {
  return _environment2 = require('../../environment');
}

var _bitMap;

function _load_bitMap() {
  return _bitMap = _interopRequireDefault(require('../bit-map'));
}

var _componentMap;

function _load_componentMap() {
  return _componentMap = _interopRequireDefault(require('../bit-map/component-map'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

var _loader;

function _load_loader() {
  return _loader = _interopRequireDefault(require('../../cli/loader'));
}

var _driver;

function _load_driver() {
  return _driver = require('../../driver');
}

var _loaderMessages;

function _load_loaderMessages() {
  return _loaderMessages = require('../../cli/loader/loader-messages');
}

var _fileSourceNotFound;

function _load_fileSourceNotFound() {
  return _fileSourceNotFound = _interopRequireDefault(require('./exceptions/file-source-not-found'));
}

var _links;

function _load_links() {
  return _links = require('../../links');
}

var _models;

function _load_models() {
  return _models = require('../../scope/models');
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('../../scope/component-dependencies'));
}

var _packageJson;

function _load_packageJson() {
  return _packageJson = _interopRequireWildcard(require('./package-json'));
}

var _dependencies;

function _load_dependencies() {
  return _dependencies = require('./dependencies');
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Component = function () {
  _createClass(Component, [{
    key: 'files',
    // whether stripOriginallySharedDir() method had been called, we don't want to strip it twice
    // otherwise they're saved as npm packages
    // needed to reduce a potentially long path that was used by the author
    set: function set(val) {
      this._files = val;
    } // needed for generate links
    ,
    get: function get() {
      if (!this._files) return null;
      if (this._files instanceof Array) return this._files;

      if ((_ramda || _load_ramda()).default.is(Object, this._files)) {
        // $FlowFixMe
        this._files = (_sources || _load_sources()).SourceFile.load(this._files);
      }
      // $FlowFixMe
      return this._files;
    }
  }, {
    key: 'id',
    get: function get() {
      return new (_bitId || _load_bitId()).default({
        scope: this.scope,
        box: this.box,
        name: this.name,
        version: this.version
      });
    }
  }, {
    key: 'docs',
    get: function get() {
      if (!this._docs) {
        this._docs = this.files ? (_ramda || _load_ramda()).default.flatten(this.files.map(function (file) {
          return (0, (_parser || _load_parser()).default)(file.contents.toString(), file.relative);
        })) : [];
      }
      return this._docs;
    }
  }, {
    key: 'driver',
    get: function get() {
      if (!this._driver) {
        this._driver = (_driver || _load_driver()).Driver.load(this.lang);
      }
      return this._driver;
    }
  }]);

  function Component(_ref) {
    var name = _ref.name,
        box = _ref.box,
        version = _ref.version,
        scope = _ref.scope,
        lang = _ref.lang,
        bindingPrefix = _ref.bindingPrefix,
        mainFile = _ref.mainFile,
        compilerId = _ref.compilerId,
        testerId = _ref.testerId,
        dependencies = _ref.dependencies,
        devDependencies = _ref.devDependencies,
        flattenedDependencies = _ref.flattenedDependencies,
        flattenedDevDependencies = _ref.flattenedDevDependencies,
        packageDependencies = _ref.packageDependencies,
        devPackageDependencies = _ref.devPackageDependencies,
        files = _ref.files,
        docs = _ref.docs,
        dists = _ref.dists,
        specsResults = _ref.specsResults,
        license = _ref.license,
        log = _ref.log,
        deprecated = _ref.deprecated;

    _classCallCheck(this, Component);

    this.dependenciesSavedAsComponents = true;
    this._writeDistsFiles = true;
    this._areDistsInsideComponentDir = true;

    this.name = name;
    this.box = box || (_constants || _load_constants()).DEFAULT_BOX_NAME;
    this.version = version;
    this.scope = scope;
    this.lang = lang || (_constants || _load_constants()).DEFAULT_LANGUAGE;
    this.bindingPrefix = bindingPrefix || (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX;
    this.mainFile = (_path || _load_path()).default.normalize(mainFile);
    this.compilerId = compilerId;
    this.testerId = testerId;
    this.setDependencies(dependencies);
    this.setDevDependencies(devDependencies);
    this.flattenedDependencies = flattenedDependencies || new (_bitIds || _load_bitIds()).default();
    this.flattenedDevDependencies = flattenedDevDependencies || new (_bitIds || _load_bitIds()).default();
    this.packageDependencies = packageDependencies || {};
    this.devPackageDependencies = devPackageDependencies || {};
    this._files = files;
    this._docs = docs;
    this.dists = dists;
    this.specsResults = specsResults;
    this.license = license;
    this.log = log;
    this.deprecated = deprecated || false;
  }

  _createClass(Component, [{
    key: 'setDependencies',
    value: function setDependencies(dependencies) {
      this.dependencies = new (_dependencies || _load_dependencies()).Dependencies(dependencies);
    }
  }, {
    key: 'setDevDependencies',
    value: function setDevDependencies(devDependencies) {
      this.devDependencies = new (_dependencies || _load_dependencies()).Dependencies(devDependencies);
    }
  }, {
    key: 'getFileExtension',
    value: function getFileExtension() {
      switch (this.lang) {
        case (_constants || _load_constants()).DEFAULT_LANGUAGE:
        default:
          return 'js';
      }
    }
  }, {
    key: '_getHomepage',
    value: function _getHomepage() {
      // TODO: Validate somehow that this scope is really on bitsrc (maybe check if it contains . ?)
      var homepage = this.scope ? `https://bitsrc.io/${this.scope.replace('.', '/')}/${this.box}/${this.name}` : undefined;
      return homepage;
    }
  }, {
    key: 'writeBitJson',
    value: function writeBitJson(bitDir) {
      var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      return new (_bitJson || _load_bitJson()).default({
        version: this.version,
        scope: this.scope,
        lang: this.lang,
        bindingPrefix: this.bindingPrefix,
        compiler: this.compilerId ? this.compilerId.toString() : (_constants || _load_constants()).NO_PLUGIN_TYPE,
        tester: this.testerId ? this.testerId.toString() : (_constants || _load_constants()).NO_PLUGIN_TYPE,
        dependencies: this.dependencies.asWritableObject(),
        devDependencies: this.devDependencies.asWritableObject(),
        packageDependencies: this.packageDependencies,
        devPackageDependencies: this.devPackageDependencies
      }).write({ bitDir, override: force });
    }
  }, {
    key: 'getPackageNameAndPath',
    value: function getPackageNameAndPath() {
      var packagePath = `${this.bindingPrefix}/${this.id.box}/${this.id.name}`;
      var packageName = this.id.toStringWithoutVersion();
      return { packageName, packagePath };
    }
  }, {
    key: 'writePackageJson',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(consumer, bitDir) {
        var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var writeBitDependencies = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
        var excludeRegistryPrefix = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt('return', (_packageJson || _load_packageJson()).write(consumer, this, bitDir, force, writeBitDependencies, excludeRegistryPrefix));

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function writePackageJson(_x5, _x6) {
        return _ref2.apply(this, arguments);
      }

      return writePackageJson;
    }()
  }, {
    key: 'flattenedDependencies',
    value: function flattenedDependencies() {
      return (_bitIds || _load_bitIds()).default.fromObject(this.flattenedDependencies);
    }
  }, {
    key: 'flattenedDevDependencies',
    value: function flattenedDevDependencies() {
      return (_bitIds || _load_bitIds()).default.fromObject(this.flattenedDevDependencies);
    }
  }, {
    key: 'getAllDependencies',
    value: function getAllDependencies() {
      return this.dependencies.dependencies.concat(this.devDependencies.dependencies);
    }
  }, {
    key: 'hasDependencies',
    value: function hasDependencies() {
      return !this.dependencies.isEmpty() || !this.devDependencies.isEmpty();
    }
  }, {
    key: 'getAllFlattenedDependencies',
    value: function getAllFlattenedDependencies() {
      return this.flattenedDependencies.concat(this.flattenedDevDependencies);
    }

    /**
     * When dists are written by a consumer (as opposed to isolated-environment for example), the dist-entry and
     * dist-target are taken into account for calculating the path.
     * By default, the dists path is inside the component. If dist attribute is populated in bit.json, the path is
     * relative to consumer root.
     */

  }, {
    key: 'getDistDirForConsumer',
    value: function getDistDirForConsumer(consumer, componentRootDir) {
      var consumerBitJson = consumer.bitJson;
      var rootDir = componentRootDir || '.';
      if (consumer.shouldDistsBeInsideTheComponent()) {
        // should be relative to component
        return (_path || _load_path()).default.join(consumer.getPath(), rootDir, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME);
      }
      // should be relative to consumer root
      if (consumerBitJson.distEntry) rootDir = rootDir.replace(consumerBitJson.distEntry, '');
      var distTarget = consumerBitJson.distTarget || (_constants || _load_constants()).DEFAULT_DIST_DIRNAME;
      this._areDistsInsideComponentDir = false;
      return (_path || _load_path()).default.join(consumer.getPath(), distTarget, rootDir);
    }
  }, {
    key: 'buildIfNeeded',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(_ref3) {
        var _this = this;

        var condition = _ref3.condition,
            files = _ref3.files,
            compiler = _ref3.compiler,
            consumer = _ref3.consumer,
            componentMap = _ref3.componentMap,
            scope = _ref3.scope,
            verbose = _ref3.verbose,
            directory = _ref3.directory,
            keep = _ref3.keep;
        var runBuild, isolatedEnvironment, isolateOpts, componentWithDependencies, component, result;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (condition) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return', Promise.resolve({ code: '' }));

              case 2:
                runBuild = function runBuild(componentRoot) {
                  var rootDistFolder = (_path || _load_path()).default.join(componentRoot, (_constants || _load_constants()).DEFAULT_DIST_DIRNAME);
                  if (componentMap) {
                    rootDistFolder = _this.getDistDirForConsumer(consumer, componentMap.rootDir);
                  }
                  try {
                    var result = compiler.compile(files, rootDistFolder);
                    return Promise.resolve(result);
                  } catch (e) {
                    if (verbose) return Promise.reject(new (_buildException || _load_buildException()).default(_this.id.toString(), e.stack));
                    return Promise.reject(new (_buildException || _load_buildException()).default(_this.id.toString(), e.message));
                  }
                };

                if (compiler.compile) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt('return', Promise.reject(`"${this.compilerId.toString()}" does not have a valid compiler interface, it has to expose a compile method`));

              case 5:
                if (!consumer) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt('return', runBuild(consumer.getPath()));

              case 7:
                if (!this.isolatedEnvironment) {
                  _context2.next = 9;
                  break;
                }

                return _context2.abrupt('return', runBuild(this.writtenPath));

              case 9:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, directory);
                _context2.prev = 10;
                _context2.next = 13;
                return isolatedEnvironment.create();

              case 13:
                isolateOpts = {
                  verbose,
                  installPackages: true,
                  noPackageJson: false
                };
                _context2.next = 16;
                return isolatedEnvironment.isolateComponent(this.id.toString(), isolateOpts);

              case 16:
                componentWithDependencies = _context2.sent;
                component = componentWithDependencies.component;
                _context2.next = 20;
                return runBuild(component.writtenPath);

              case 20:
                result = _context2.sent;

                if (keep) {
                  _context2.next = 24;
                  break;
                }

                _context2.next = 24;
                return isolatedEnvironment.destroy();

              case 24:
                return _context2.abrupt('return', result);

              case 27:
                _context2.prev = 27;
                _context2.t0 = _context2['catch'](10);
                _context2.next = 31;
                return isolatedEnvironment.destroy();

              case 31:
                return _context2.abrupt('return', Promise.reject(_context2.t0));

              case 32:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[10, 27]]);
      }));

      function buildIfNeeded(_x7) {
        return _ref4.apply(this, arguments);
      }

      return buildIfNeeded;
    }()
  }, {
    key: '_writeToComponentDir',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref5) {
        var bitDir = _ref5.bitDir,
            writeBitJson = _ref5.writeBitJson,
            writePackageJson = _ref5.writePackageJson,
            consumer = _ref5.consumer,
            _ref5$force = _ref5.force,
            force = _ref5$force === undefined ? true : _ref5$force,
            _ref5$writeBitDepende = _ref5.writeBitDependencies,
            writeBitDependencies = _ref5$writeBitDepende === undefined ? false : _ref5$writeBitDepende,
            _ref5$deleteBitDirCon = _ref5.deleteBitDirContent,
            deleteBitDirContent = _ref5$deleteBitDirCon === undefined ? false : _ref5$deleteBitDirCon,
            _ref5$excludeRegistry = _ref5.excludeRegistryPrefix,
            excludeRegistryPrefix = _ref5$excludeRegistry === undefined ? false : _ref5$excludeRegistry;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!deleteBitDirContent) {
                  _context3.next = 4;
                  break;
                }

                (_fsExtra || _load_fsExtra()).default.emptydirSync(bitDir);
                _context3.next = 6;
                break;

              case 4:
                _context3.next = 6;
                return (0, (_utils || _load_utils()).mkdirp)(bitDir);

              case 6:
                if (!this.files) {
                  _context3.next = 9;
                  break;
                }

                _context3.next = 9;
                return this.files.forEach(function (file) {
                  return file.write(undefined, force);
                });

              case 9:
                if (!(this.dists && this._writeDistsFiles)) {
                  _context3.next = 12;
                  break;
                }

                _context3.next = 12;
                return this.writeDists(consumer, false);

              case 12:
                if (!writeBitJson) {
                  _context3.next = 15;
                  break;
                }

                _context3.next = 15;
                return this.writeBitJson(bitDir, force);

              case 15:
                if (!(writePackageJson && (consumer.isolated || bitDir !== consumer.getPath()))) {
                  _context3.next = 18;
                  break;
                }

                _context3.next = 18;
                return this.writePackageJson(consumer, bitDir, force, writeBitDependencies, excludeRegistryPrefix);

              case 18:
                if (!(this.license && this.license.src)) {
                  _context3.next = 21;
                  break;
                }

                _context3.next = 21;
                return this.license.write(bitDir, force);

              case 21:
                (_logger || _load_logger()).default.debug('component has been written successfully');
                return _context3.abrupt('return', this);

              case 23:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _writeToComponentDir(_x8) {
        return _ref6.apply(this, arguments);
      }

      return _writeToComponentDir;
    }()
  }, {
    key: 'getComponentMap',
    value: function getComponentMap(bitMap) {
      return bitMap.getComponent(this.id);
    }
  }, {
    key: '_addComponentToBitMap',
    value: function _addComponentToBitMap(bitMap, rootDir, origin, parent) {
      var filesForBitMap = this.files.map(function (file) {
        return { name: file.basename, relativePath: (0, (_utils || _load_utils()).pathNormalizeToLinux)(file.relative), test: file.test };
      });

      return bitMap.addComponent({
        componentId: this.id,
        files: filesForBitMap,
        mainFile: this.mainFile,
        rootDir,
        origin,
        parent,
        originallySharedDir: this.originallySharedDir
      });
    }

    /**
     * Before writing the files into the file-system, remove the path-prefix that is shared among the main component files
     * and its dependencies. It helps to avoid large file-system paths.
     *
     * This is relevant for IMPORTED components only as the author may have long paths that are not needed for whoever
     * imports it. NESTED and AUTHORED components are written as is.
     */

  }, {
    key: 'stripOriginallySharedDir',
    value: function stripOriginallySharedDir(bitMap) {
      if (this._wasOriginallySharedDirStripped) return;
      this.setOriginallySharedDir();
      var originallySharedDir = this.originallySharedDir;
      if (originallySharedDir) {
        (_logger || _load_logger()).default.debug(`stripping originallySharedDir "${originallySharedDir}" from ${this.id}`);
      }
      var pathWithoutSharedDir = function pathWithoutSharedDir(pathStr, sharedDir) {
        if (!sharedDir) return pathStr;
        var partToRemove = (_path || _load_path()).default.normalize(sharedDir) + (_path || _load_path()).default.sep;
        return pathStr.replace(partToRemove, '');
      };
      this.files.forEach(function (file) {
        var newRelative = pathWithoutSharedDir(file.relative, originallySharedDir);
        file.updatePaths({ newBase: file.base, newRelative });
      });
      if (this.dists) {
        this.dists.forEach(function (distFile) {
          var newRelative = pathWithoutSharedDir(distFile.relative, originallySharedDir);
          distFile.updatePaths({ newBase: distFile.base, newRelative });
        });
      }
      this.mainFile = pathWithoutSharedDir(this.mainFile, originallySharedDir);
      this.dependencies.stripOriginallySharedDir(bitMap, originallySharedDir);
      this.devDependencies.stripOriginallySharedDir(bitMap, originallySharedDir);
      this._wasOriginallySharedDirStripped = true;
    }
  }, {
    key: 'updateDistsPerConsumerBitJson',
    value: function updateDistsPerConsumerBitJson(consumer, componentMap) {
      var _this2 = this;

      if (this._distsPathsAreUpdated || !this.dists) return;
      var newDistBase = this.getDistDirForConsumer(consumer, componentMap.rootDir);
      var distEntry = consumer.bitJson.distEntry;
      var shouldDistEntryBeStripped = function shouldDistEntryBeStripped() {
        if (!distEntry || componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED) return false;
        var areAllDistsStartWithDistEntry = function areAllDistsStartWithDistEntry() {
          return _this2.dists.map(function (dist) {
            return dist.relative.startsWith(distEntry);
          }).every(function (x) {
            return x;
          });
        };
        if (componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED) {
          return areAllDistsStartWithDistEntry();
        }
        // it's IMPORTED. We first check that rootDir starts with dist.entry, it happens mostly when a user imports into
        // a specific directory (e.g. bit import --path src/). Then, we make sure all dists files start with that
        // dist.entry. In a case when originallySharedDir is the same as dist.entry, this second check returns false.
        return componentMap.rootDir.startsWith(distEntry) && areAllDistsStartWithDistEntry();
      };
      var distEntryShouldBeStripped = shouldDistEntryBeStripped();
      if (distEntryShouldBeStripped) {
        (_logger || _load_logger()).default.debug(`stripping dist.entry "${distEntry}" from ${this.id}`);
        this.distEntryShouldBeStripped = true;
      }
      var getNewRelative = function getNewRelative(dist) {
        if (distEntryShouldBeStripped) {
          return dist.relative.replace(distEntry, '');
        }
        return dist.relative;
      };
      this.dists.forEach(function (dist) {
        return dist.updatePaths({ newBase: newDistBase, newRelative: getNewRelative(dist) });
      });
      this._distsPathsAreUpdated = true;
    }

    /**
     * When using this function please check if you really need to pass the bitDir or not
     * It's better to init the files with the correct base, cwd and path than pass it here
     * It's mainly here for cases when we write from the model so this is the first point we actually have the dir
     */

  }, {
    key: 'write',
    value: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(_ref7) {
        var bitDir = _ref7.bitDir,
            _ref7$writeBitJson = _ref7.writeBitJson,
            writeBitJson = _ref7$writeBitJson === undefined ? true : _ref7$writeBitJson,
            _ref7$writePackageJso = _ref7.writePackageJson,
            writePackageJson = _ref7$writePackageJso === undefined ? true : _ref7$writePackageJso,
            _ref7$force = _ref7.force,
            force = _ref7$force === undefined ? true : _ref7$force,
            origin = _ref7.origin,
            parent = _ref7.parent,
            consumer = _ref7.consumer,
            _ref7$writeBitDepende = _ref7.writeBitDependencies,
            writeBitDependencies = _ref7$writeBitDepende === undefined ? false : _ref7$writeBitDepende,
            componentMap = _ref7.componentMap,
            _ref7$excludeRegistry = _ref7.excludeRegistryPrefix,
            excludeRegistryPrefix = _ref7$excludeRegistry === undefined ? false : _ref7$excludeRegistry;
        var consumerPath, bitMap, calculatedBitDir, deleteBitDirContent, oldLocation, newBase, actualWithPackageJson;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`consumer-component.write, id: ${this.id.toString()}`);
                consumerPath = consumer ? consumer.getPath() : undefined;
                bitMap = consumer ? consumer.bitMap : undefined;

                if (this.files) {
                  _context4.next = 5;
                  break;
                }

                throw new Error(`Component ${this.id.toString()} is invalid as it has no files`);

              case 5:
                // Take the bitdir from the files (it will be the same for all the files of course)
                calculatedBitDir = bitDir || this.files[0].base;
                // Update files base dir according to bitDir

                if (this.files && bitDir) this.files.forEach(function (file) {
                  return file.updatePaths({ newBase: bitDir });
                });
                if (this.dists && bitDir) this.dists.forEach(function (dist) {
                  return dist.updatePaths({ newBase: bitDir });
                });

                // if bitMap parameter is empty, for instance, when it came from the scope, ignore bitMap altogether.
                // otherwise, check whether this component is in bitMap:
                // if it's there, write the files according to the paths in bit.map.
                // Otherwise, write to bitDir and update bitMap with the new paths.

                if (bitMap) {
                  _context4.next = 10;
                  break;
                }

                return _context4.abrupt('return', this._writeToComponentDir({
                  bitDir: calculatedBitDir,
                  writeBitJson,
                  writePackageJson,
                  consumer,
                  force,
                  writeBitDependencies,
                  excludeRegistryPrefix
                }));

              case 10:
                if (!componentMap) {
                  // if there is no componentMap, the component is new to this project and should be written to bit.map
                  componentMap = this._addComponentToBitMap(bitMap, calculatedBitDir, origin, parent);
                }
                if (!consumer.shouldDistsBeInsideTheComponent() && !this.dists) {
                  // since the dists are set to be outside the components dir, the source files must be saved there
                  // otherwise, other components in dists won't be able to link to this component
                  this.copyFilesIntoDists();
                }
                // For IMPORTED component we have to delete the content of the directory before importing.
                // Otherwise, when the author adds new files outside of the previous originallySharedDir and this user imports them
                // the environment will contain both copies, the old one with the old originallySharedDir and the new one.
                // If a user made changes to the imported component, it will show a warning and stop the process.
                deleteBitDirContent = origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED;
                // when there is componentMap, this component (with this version or other version) is already part of the project.
                // There are several options as to what was the origin before and what is the origin now and according to this,
                // we update/remove/don't-touch the record in bit.map.
                // The current origin can't be AUTHORED because when the author creates a component for the first time,
                // 1) current origin is AUTHORED - If the version is the same as before, don't update bit.map. Otherwise, update.
                // 2) current origin is IMPORTED - If the version is the same as before, don't update bit.map. Otherwise, update.
                // one exception is where the origin was NESTED before, in this case, remove the current record and add a new one.
                // 3) current origin is NESTED - the version can't be the same as before (otherwise it would be ignored before and
                // never reach this function, see @writeToComponentsDir). Therefore, always add to bit.map.

                if (origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED && componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.NESTED) {
                  // when a user imports a component that was a dependency before, write the component directly into the components
                  // directory for an easy access/change. Then, remove the current record from bit.map and add an updated one.
                  oldLocation = (_path || _load_path()).default.join(consumerPath, componentMap.rootDir);

                  (_logger || _load_logger()).default.debug(`deleting the old directory of a component at ${oldLocation}, the new directory is ${calculatedBitDir}`);
                  (_fsExtra || _load_fsExtra()).default.removeSync(oldLocation);
                  bitMap.removeComponent(this.id.toString());
                  componentMap = this._addComponentToBitMap(bitMap, calculatedBitDir, origin, parent);
                }
                (_logger || _load_logger()).default.debug('component is in bit.map, write the files according to bit.map');
                if (componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED) writeBitJson = false;
                newBase = componentMap.rootDir ? (_path || _load_path()).default.join(consumerPath, componentMap.rootDir) : consumerPath;

                this.writtenPath = newBase;
                this.files.forEach(function (file) {
                  return file.updatePaths({ newBase });
                });
                // Don't write the package.json for an authored component, because it's dependencies probably managed
                // By the root package.json
                actualWithPackageJson = writePackageJson && origin !== (_constants || _load_constants()).COMPONENT_ORIGINS.AUTHORED;
                _context4.next = 22;
                return this._writeToComponentDir({
                  bitDir: newBase,
                  writeBitJson,
                  writePackageJson: actualWithPackageJson,
                  consumer,
                  force,
                  writeBitDependencies,
                  deleteBitDirContent,
                  excludeRegistryPrefix
                });

              case 22:
                if (!bitMap.isExistWithSameVersion(this.id)) {
                  _context4.next = 24;
                  break;
                }

                return _context4.abrupt('return', this);

              case 24:
                // no need to update bit.map
                this._addComponentToBitMap(bitMap, componentMap.rootDir, origin, parent);
                return _context4.abrupt('return', this);

              case 26:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function write(_x9) {
        return _ref8.apply(this, arguments);
      }

      return write;
    }()

    /**
     * write dists file to the filesystem. In case there is a consumer and dist.entry should be stripped, it will be
     * done before writing the files. The originallySharedDir should be already stripped before accessing this method.
     */

  }, {
    key: 'writeDists',
    value: function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(consumer) {
        var writeLinks = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var componentMap, saveDist;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (this.dists) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt('return', null);

              case 2:
                componentMap = void 0;

                if (consumer) {
                  componentMap = consumer.bitMap.getComponent(this.id);
                  this.updateDistsPerConsumerBitJson(consumer, componentMap);
                }
                saveDist = this.dists.map(function (distFile) {
                  return distFile.write();
                });

                if (!(writeLinks && componentMap && componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED)) {
                  _context5.next = 8;
                  break;
                }

                _context5.next = 8;
                return (0, (_links || _load_links()).writeLinksInDist)(this, componentMap, consumer);

              case 8:
                return _context5.abrupt('return', Promise.all(saveDist));

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function writeDists(_x11) {
        return _ref9.apply(this, arguments);
      }

      return writeDists;
    }()
  }, {
    key: 'runSpecs',
    value: function () {
      var _ref11 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(_ref10) {
        var _this3 = this;

        var scope = _ref10.scope,
            rejectOnFailure = _ref10.rejectOnFailure,
            consumer = _ref10.consumer,
            save = _ref10.save,
            verbose = _ref10.verbose,
            isolated = _ref10.isolated,
            directory = _ref10.directory,
            keep = _ref10.keep,
            _ref10$isCI = _ref10.isCI,
            isCI = _ref10$isCI === undefined ? false : _ref10$isCI;
        var testFiles, testerFilePath, run, testDists, isolatedEnvironment, isolateOpts, componentWithDependencies, component, specDistWrite, testFilesList, results;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                testFiles = this.files.filter(function (file) {
                  return file.test;
                });

                if (!(!this.testerId || !testFiles || (_ramda || _load_ramda()).default.isEmpty(testFiles))) {
                  _context8.next = 3;
                  break;
                }

                return _context8.abrupt('return', null);

              case 3:
                testerFilePath = scope.loadEnvironment(this.testerId, { pathOnly: true });

                if (testerFilePath) {
                  _context8.next = 9;
                  break;
                }

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ENVIRONMENT);
                _context8.next = 8;
                return scope.installEnvironment({
                  ids: [this.testerId],
                  verbose
                });

              case 8:
                testerFilePath = scope.loadEnvironment(this.testerId, { pathOnly: true });

              case 9:
                (_logger || _load_logger()).default.debug('Environment components are installed.');

                _context8.prev = 10;

                run = function () {
                  var _ref12 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(mainFile, distTestFiles) {
                    var specsResultsP, _specsResults;

                    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
                      while (1) {
                        switch (_context7.prev = _context7.next) {
                          case 0:
                            (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_RUNNING_SPECS);
                            _context7.prev = 1;
                            specsResultsP = distTestFiles.map(function () {
                              var _ref13 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(testFile) {
                                return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
                                  while (1) {
                                    switch (_context6.prev = _context6.next) {
                                      case 0:
                                        return _context6.abrupt('return', (_specsRunner || _load_specsRunner()).default.run({
                                          scope,
                                          testerFilePath,
                                          testerId: _this3.testerId,
                                          mainFile,
                                          testFile
                                        }));

                                      case 1:
                                      case 'end':
                                        return _context6.stop();
                                    }
                                  }
                                }, _callee6, _this3);
                              }));

                              return function (_x15) {
                                return _ref13.apply(this, arguments);
                              };
                            }());
                            _context7.next = 5;
                            return Promise.all(specsResultsP);

                          case 5:
                            _specsResults = _context7.sent;

                            _this3.specsResults = _specsResults.map(function (specRes) {
                              return (_specsResults2 || _load_specsResults()).default.createFromRaw(specRes);
                            });

                            if (!(rejectOnFailure && !_this3.specsResults.every(function (element) {
                              return element.pass;
                            }))) {
                              _context7.next = 9;
                              break;
                            }

                            return _context7.abrupt('return', Promise.reject(new (_componentSpecsFailed || _load_componentSpecsFailed()).default()));

                          case 9:
                            if (!save) {
                              _context7.next = 13;
                              break;
                            }

                            _context7.next = 12;
                            return scope.sources.modifySpecsResults({
                              source: _this3,
                              specsResults: _this3.specsResults
                            });

                          case 12:
                            return _context7.abrupt('return', _this3.specsResults);

                          case 13:
                            return _context7.abrupt('return', _this3.specsResults);

                          case 16:
                            _context7.prev = 16;
                            _context7.t0 = _context7['catch'](1);

                            if (!verbose) {
                              _context7.next = 20;
                              break;
                            }

                            throw _context7.t0;

                          case 20:
                            throw new (_componentSpecsFailed || _load_componentSpecsFailed()).default();

                          case 21:
                          case 'end':
                            return _context7.stop();
                        }
                      }
                    }, _callee7, _this3, [[1, 16]]);
                  }));

                  return function run(_x13, _x14) {
                    return _ref12.apply(this, arguments);
                  };
                }();

                if (!(!isolated && consumer)) {
                  _context8.next = 20;
                  break;
                }

                (_logger || _load_logger()).default.debug('Building the component before running the tests');
                _context8.next = 16;
                return this.build({ scope, verbose, consumer });

              case 16:
                _context8.next = 18;
                return this.writeDists(consumer);

              case 18:
                testDists = this.dists ? this.dists.filter(function (dist) {
                  return dist.test;
                }) : this.files.filter(function (file) {
                  return file.test;
                });
                return _context8.abrupt('return', run(this.mainFile, testDists));

              case 20:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, directory);
                _context8.prev = 21;
                _context8.next = 24;
                return isolatedEnvironment.create();

              case 24:
                isolateOpts = {
                  verbose,
                  dist: true,
                  installPackages: true,
                  noPackageJson: false
                };
                _context8.next = 27;
                return isolatedEnvironment.isolateComponent(this.id.toString(), isolateOpts);

              case 27:
                componentWithDependencies = _context8.sent;
                component = componentWithDependencies.component;

                component.isolatedEnvironment = isolatedEnvironment;
                (_logger || _load_logger()).default.debug(`the component ${this.id.toString()} has been imported successfully into an isolated environment`);

                _context8.next = 33;
                return component.build({ scope, verbose });

              case 33:
                if (!component.dists) {
                  _context8.next = 37;
                  break;
                }

                specDistWrite = component.dists.map(function (file) {
                  return file.write();
                });
                _context8.next = 37;
                return Promise.all(specDistWrite);

              case 37:
                testFilesList = component.dists ? component.dists.filter(function (dist) {
                  return dist.test;
                }) : component.files.filter(function (file) {
                  return file.test;
                });
                _context8.next = 40;
                return run(component.mainFile, testFilesList);

              case 40:
                results = _context8.sent;

                if (keep) {
                  _context8.next = 44;
                  break;
                }

                _context8.next = 44;
                return isolatedEnvironment.destroy();

              case 44:
                return _context8.abrupt('return', isCI ? { specResults: results, mainFile: this.calculateMainDistFile() } : results);

              case 47:
                _context8.prev = 47;
                _context8.t0 = _context8['catch'](21);
                _context8.next = 51;
                return isolatedEnvironment.destroy();

              case 51:
                return _context8.abrupt('return', Promise.reject(_context8.t0));

              case 52:
                _context8.next = 57;
                break;

              case 54:
                _context8.prev = 54;
                _context8.t1 = _context8['catch'](10);
                return _context8.abrupt('return', Promise.reject(_context8.t1));

              case 57:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this, [[10, 54], [21, 47]]);
      }));

      function runSpecs(_x12) {
        return _ref11.apply(this, arguments);
      }

      return runSpecs;
    }()
  }, {
    key: 'copyFilesIntoDists',
    value: function copyFilesIntoDists() {
      this.dists = this.files.map(function (file) {
        return new (_sources || _load_sources()).Dist({ base: file.base, path: file.path, contents: file.contents });
      });
    }
  }, {
    key: 'build',
    value: function () {
      var _ref15 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee10(_ref14) {
        var _this4 = this;

        var scope = _ref14.scope,
            save = _ref14.save,
            consumer = _ref14.consumer,
            verbose = _ref14.verbose,
            directory = _ref14.directory,
            keep = _ref14.keep,
            _ref14$isCI = _ref14.isCI,
            isCI = _ref14$isCI === undefined ? false : _ref14$isCI;
        var isNeededToReBuild, bitMap, componentMap, needToRebuild, compiler, builtFiles;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`consumer-component.build ${this.id}`);
                // @TODO - write SourceMap Type

                if (this.compilerId) {
                  _context10.next = 8;
                  break;
                }

                if (!(!consumer || consumer.shouldDistsBeInsideTheComponent())) {
                  _context10.next = 5;
                  break;
                }

                (_logger || _load_logger()).default.debug('compilerId was not found, nothing to build');
                return _context10.abrupt('return', Promise.resolve(null));

              case 5:
                (_logger || _load_logger()).default.debug('compilerId was not found, however, because the dists are set to be outside the components directory, save the source file as dists');
                this.copyFilesIntoDists();
                return _context10.abrupt('return', this.dists);

              case 8:
                // Ideally it's better to use the dists from the model.
                // If there is no consumer, it comes from the scope or isolated environment, which the dists are already saved.
                // If there is consumer, check whether the component was modified. If it wasn't, no need to re-build.
                isNeededToReBuild = function () {
                  var _ref16 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee9() {
                    var componentStatus;
                    return (_regenerator || _load_regenerator()).default.wrap(function _callee9$(_context9) {
                      while (1) {
                        switch (_context9.prev = _context9.next) {
                          case 0:
                            if (consumer) {
                              _context9.next = 2;
                              break;
                            }

                            return _context9.abrupt('return', false);

                          case 2:
                            _context9.next = 4;
                            return consumer.getComponentStatusById(_this4.id);

                          case 4:
                            componentStatus = _context9.sent;
                            return _context9.abrupt('return', componentStatus.modified);

                          case 6:
                          case 'end':
                            return _context9.stop();
                        }
                      }
                    }, _callee9, _this4);
                  }));

                  return function isNeededToReBuild() {
                    return _ref16.apply(this, arguments);
                  };
                }();

                bitMap = consumer ? consumer.bitMap : undefined;
                componentMap = bitMap && bitMap.getComponent(this.id.toString());
                _context10.next = 13;
                return isNeededToReBuild();

              case 13:
                needToRebuild = _context10.sent;

                if (!(!needToRebuild && this.dists)) {
                  _context10.next = 18;
                  break;
                }

                (_logger || _load_logger()).default.debug('skip the build process as the component was not modified, use the dists saved in the model');
                if (componentMap && componentMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED) {
                  this.stripOriginallySharedDir(bitMap);
                  // don't worry about the dist.entry and dist.target at this point. It'll be done later on once the files are
                  // written, probably by this.writeDists()
                }

                return _context10.abrupt('return', isCI ? { mainFile: this.calculateMainDistFile(), dists: this.dists } : this.dist);

              case 18:

                (_logger || _load_logger()).default.debug('compilerId found, start building');

                compiler = scope.loadEnvironment(this.compilerId);

                if (compiler) {
                  _context10.next = 25;
                  break;
                }

                (_loader || _load_loader()).default.start((_loaderMessages || _load_loaderMessages()).BEFORE_IMPORT_ENVIRONMENT);
                _context10.next = 24;
                return scope.installEnvironment({
                  ids: [this.compilerId],
                  verbose
                });

              case 24:
                compiler = scope.loadEnvironment(this.compilerId);

              case 25:
                _context10.next = 27;
                return this.buildIfNeeded({
                  condition: !!this.compilerId,
                  compiler,
                  files: this.files,
                  consumer,
                  componentMap,
                  scope,
                  directory,
                  keep,
                  verbose
                });

              case 27:
                builtFiles = _context10.sent;

                // return buildFilesP.then((buildedFiles) => {
                builtFiles.forEach(function (file) {
                  if (file && (!file.contents || !(0, (_utils || _load_utils()).isString)(file.contents.toString()))) {
                    throw new Error('builder interface has to return object with a code attribute that contains string');
                  }
                });

                this.dists = builtFiles.map(function (file) {
                  return new (_sources || _load_sources()).Dist(file);
                });

                if (!save) {
                  _context10.next = 33;
                  break;
                }

                _context10.next = 33;
                return scope.sources.updateDist({ source: this });

              case 33:
                return _context10.abrupt('return', this.dists);

              case 34:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function build(_x16) {
        return _ref15.apply(this, arguments);
      }

      return build;
    }()
  }, {
    key: 'isolate',
    value: function () {
      var _ref17 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee11(scope, opts) {
        var isolatedEnvironment;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                isolatedEnvironment = new (_environment || _load_environment()).default(scope, opts.writeToPath);
                _context11.prev = 1;
                _context11.next = 4;
                return isolatedEnvironment.create();

              case 4:
                _context11.next = 6;
                return isolatedEnvironment.isolateComponent(this.id.toString(), opts);

              case 6:
                return _context11.abrupt('return', isolatedEnvironment.path);

              case 9:
                _context11.prev = 9;
                _context11.t0 = _context11['catch'](1);
                _context11.next = 13;
                return isolatedEnvironment.destroy();

              case 13:
                throw new Error(_context11.t0);

              case 14:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this, [[1, 9]]);
      }));

      function isolate(_x17, _x18) {
        return _ref17.apply(this, arguments);
      }

      return isolate;
    }()
  }, {
    key: 'toObject',
    value: function toObject() {
      return {
        name: this.name,
        box: this.box,
        version: this.version,
        mainFile: this.mainFile,
        scope: this.scope,
        lang: this.lang,
        bindingPrefix: this.bindingPrefix,
        compilerId: this.compilerId ? this.compilerId.toString() : null,
        testerId: this.testerId ? this.testerId.toString() : null,
        dependencies: this.dependencies.serialize(),
        devDependencies: this.devDependencies.serialize(),
        packageDependencies: this.packageDependencies,
        devPackageDependencies: this.devPackageDependencies,
        files: this.files,
        docs: this.docs,
        dists: this.dists,
        specsResults: this.specsResults ? this.specsResults.map(function (res) {
          return res.serialize();
        }) : null,
        license: this.license ? this.license.serialize() : null,
        log: this.log,
        deprecated: this.deprecated
      };
    }
  }, {
    key: 'toString',
    value: function toString() {
      return JSON.stringify(this.toObject());
    }

    // In case there are dist files, we want to point the index to the main dist file, not to source.
    // This important since when you require a module without specify file, it will give you the file specified under this key
    // (or index.js if key not exists)

  }, {
    key: 'calculateMainDistFile',
    value: function calculateMainDistFile() {
      if (this._writeDistsFiles && this._areDistsInsideComponentDir) {
        var _mainFile = (0, (_utils || _load_utils()).searchFilesIgnoreExt)(this.dists, this.mainFile, 'relative', 'relative');
        if (_mainFile) return (_path || _load_path()).default.join((_constants || _load_constants()).DEFAULT_DIST_DIRNAME, _mainFile);
      }
      return this.mainFile;
    }

    /**
     * authored components have the dists outside the components dir and they don't have rootDir.
     * it returns the main file or main dist file relative to consumer-root.
     */

  }, {
    key: 'calculateMainDistFileForAuthored',
    value: function calculateMainDistFileForAuthored(consumer) {
      var _this5 = this;

      if (!this.dists) return this.mainFile;
      var getMainFileToSearch = function getMainFileToSearch() {
        if (!consumer.bitJson.distEntry) return _this5.mainFile;
        var distEntryNormalized = (_path || _load_path()).default.normalize(consumer.bitJson.distEntry);
        return _this5.mainFile.replace(`${distEntryNormalized}${(_path || _load_path()).default.sep}`, '');
      };
      var mainFileToSearch = getMainFileToSearch();
      var distMainFile = (0, (_utils || _load_utils()).searchFilesIgnoreExt)(this.dists, mainFileToSearch, 'relative', 'relative');
      if (!distMainFile) return this.mainFile;
      var distTarget = consumer.bitJson.distTarget || (_constants || _load_constants()).DEFAULT_DIST_DIRNAME;
      return (_path || _load_path()).default.join(distTarget, distMainFile);
    }

    /**
     * find a shared directory among the files of the main component and its dependencies
     */

  }, {
    key: 'setOriginallySharedDir',
    value: function setOriginallySharedDir() {
      if (this.originallySharedDir !== undefined) return;
      // taken from https://stackoverflow.com/questions/1916218/find-the-longest-common-starting-substring-in-a-set-of-strings
      // It sorts the array, and then looks just at the first and last items
      var sharedStartOfArray = function sharedStartOfArray(array) {
        var sortedArray = array.concat().sort();
        var firstItem = sortedArray[0];
        var lastItem = sortedArray[sortedArray.length - 1];
        var i = 0;
        while (i < firstItem.length && firstItem.charAt(i) === lastItem.charAt(i)) {
          i++;
        }return firstItem.substring(0, i);
      };
      var pathSep = '/'; // it works for Windows as well as all paths are normalized to Linux
      var filePaths = this.files.map(function (file) {
        return (0, (_utils || _load_utils()).pathNormalizeToLinux)(file.relative);
      });
      var dependenciesPaths = this.dependencies.getSourcesPaths();
      var devDependenciesPaths = this.devDependencies.getSourcesPaths();
      var allPaths = [].concat(_toConsumableArray(filePaths), _toConsumableArray(dependenciesPaths), _toConsumableArray(devDependenciesPaths));
      var sharedStart = sharedStartOfArray(allPaths);
      if (!sharedStart || !sharedStart.includes(pathSep)) return;
      var lastPathSeparator = sharedStart.lastIndexOf(pathSep);
      this.originallySharedDir = sharedStart.substring(0, lastPathSeparator);
    }
  }, {
    key: 'toComponentWithDependencies',
    value: function () {
      var _ref18 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee12(consumer) {
        var dependencies, devDependencies;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.dependencies.getDependenciesComponents(consumer, this);

              case 2:
                dependencies = _context12.sent;
                _context12.next = 5;
                return this.devDependencies.getDependenciesComponents(consumer, this);

              case 5:
                devDependencies = _context12.sent;
                return _context12.abrupt('return', new (_componentDependencies || _load_componentDependencies()).default({ component: this, dependencies, devDependencies }));

              case 7:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function toComponentWithDependencies(_x19) {
        return _ref18.apply(this, arguments);
      }

      return toComponentWithDependencies;
    }()
  }], [{
    key: 'fromObject',
    value: function fromObject(object) {
      var name = object.name,
          box = object.box,
          version = object.version,
          scope = object.scope,
          lang = object.lang,
          bindingPrefix = object.bindingPrefix,
          compilerId = object.compilerId,
          testerId = object.testerId,
          dependencies = object.dependencies,
          devDependencies = object.devDependencies,
          packageDependencies = object.packageDependencies,
          devPackageDependencies = object.devPackageDependencies,
          docs = object.docs,
          mainFile = object.mainFile,
          dists = object.dists,
          files = object.files,
          specsResults = object.specsResults,
          license = object.license,
          deprecated = object.deprecated;

      return new Component({
        name,
        box,
        version,
        scope,
        lang,
        bindingPrefix,
        compilerId: compilerId ? (_bitId || _load_bitId()).default.parse(compilerId) : null,
        testerId: testerId ? (_bitId || _load_bitId()).default.parse(testerId) : null,
        dependencies,
        devDependencies,
        packageDependencies,
        devPackageDependencies,
        mainFile,
        files,
        docs,
        dists,
        specsResults: specsResults ? (_specsResults2 || _load_specsResults()).default.deserialize(specsResults) : null,
        license: license ? (_sources || _load_sources()).License.deserialize(license) : null,
        deprecated: deprecated || false
      });
    }
  }, {
    key: 'fromString',
    value: function fromString(str) {
      var object = JSON.parse(str);
      object.files = (_sources || _load_sources()).SourceFile.loadFromParsedStringArray(object.files);
      object.dists = (_sources || _load_sources()).Dist.loadFromParsedStringArray(object.dists);
      return this.fromObject(object);
    }
  }, {
    key: 'loadFromFileSystem',
    value: function loadFromFileSystem(_ref19) {
      var bitDir = _ref19.bitDir,
          componentMap = _ref19.componentMap,
          id = _ref19.id,
          consumer = _ref19.consumer,
          componentFromModel = _ref19.componentFromModel;

      var consumerPath = consumer.getPath();
      var consumerBitJson = consumer.bitJson;
      var bitMap = consumer.bitMap;
      var deprecated = componentFromModel ? componentFromModel.component.deprecated : false;
      var dists = componentFromModel ? componentFromModel.component.dists : undefined;
      var packageDependencies = void 0;
      var devPackageDependencies = void 0;
      var bitJson = consumerBitJson;
      var getLoadedFiles = function getLoadedFiles(files) {
        var sourceFiles = [];
        var filesKeysToDelete = [];
        files.forEach(function (file, key) {
          var filePath = (_path || _load_path()).default.join(bitDir, file.relativePath);
          try {
            var sourceFile = (_sources || _load_sources()).SourceFile.load(filePath, consumerBitJson.distTarget, bitDir, consumerPath, {
              test: file.test
            });
            sourceFiles.push(sourceFile);
          } catch (err) {
            if (!(err instanceof (_fileSourceNotFound || _load_fileSourceNotFound()).default)) throw err;
            (_logger || _load_logger()).default.warn(`a file ${filePath} will be deleted from bit.map as it does not exist on the file system`);
            filesKeysToDelete.push(key);
          }
        });
        if (filesKeysToDelete.length && !sourceFiles.length) {
          throw new (_missingFilesFromComponent || _load_missingFilesFromComponent()).default(id.toString());
        }
        if (filesKeysToDelete.length) {
          filesKeysToDelete.forEach(function (key) {
            return files.splice(key, 1);
          });
          bitMap.hasChanged = true;
        }

        return sourceFiles;
      };
      if (!(_fsExtra || _load_fsExtra()).default.existsSync(bitDir)) return Promise.reject(new (_componentNotFoundInPath || _load_componentNotFoundInPath()).default(bitDir));
      var files = componentMap.files;
      // Load the base entry from the root dir in map file in case it was imported using -path
      // Or created using bit create so we don't want all the path but only the relative one
      // Check that bitDir isn't the same as consumer path to make sure we are not loading global stuff into component
      // (like dependencies)
      if (bitDir !== consumerPath) {
        bitJson = (_bitJson || _load_bitJson()).default.loadSync(bitDir, consumerBitJson);
        if (bitJson) {
          packageDependencies = bitJson.packageDependencies;
          devPackageDependencies = bitJson.devPackageDependencies;
        }
      }

      // by default, imported components are not written with bit.json file.
      // use the component from the model to get their bit.json values
      if (!(_fsExtra || _load_fsExtra()).default.existsSync((_path || _load_path()).default.join(bitDir, (_constants || _load_constants()).BIT_JSON)) && componentFromModel) {
        bitJson.mergeWithComponentData(componentFromModel.component);
      }

      // Remove dists if compiler has been deleted
      if (dists && !bitJson.compilerId) {
        dists = undefined;
      }

      return new Component({
        name: id.name,
        box: id.box,
        scope: id.scope,
        version: id.version,
        lang: bitJson.lang,
        bindingPrefix: bitJson.bindingPrefix || (_constants || _load_constants()).DEFAULT_BINDINGS_PREFIX,
        compilerId: (_bitId || _load_bitId()).default.parse(bitJson.compilerId),
        testerId: (_bitId || _load_bitId()).default.parse(bitJson.testerId),
        mainFile: componentMap.mainFile,
        files: getLoadedFiles(files),
        dists,
        packageDependencies,
        devPackageDependencies,
        deprecated
      });
    }
  }, {
    key: 'create',
    value: function create(_ref20, scope) {
      var scopeName = _ref20.scopeName,
          name = _ref20.name,
          box = _ref20.box,
          withSpecs = _ref20.withSpecs,
          files = _ref20.files,
          mainFile = _ref20.mainFile,
          consumerBitJson = _ref20.consumerBitJson,
          bitPath = _ref20.bitPath,
          consumerPath = _ref20.consumerPath;

      var specsFile = consumerBitJson.getSpecBasename();
      var compilerId = (_bitId || _load_bitId()).default.parse(consumerBitJson.compilerId);
      var testerId = (_bitId || _load_bitId()).default.parse(consumerBitJson.testerId);
      var lang = consumerBitJson.lang;
      var bindingPrefix = consumerBitJson.bindingPrefix;
      var implVinylFile = new (_sources || _load_sources()).SourceFile({
        cwd: consumerPath,
        base: (_path || _load_path()).default.join(consumerPath, bitPath),
        path: (_path || _load_path()).default.join(consumerPath, bitPath, files['impl.js']),
        contents: new Buffer((_sources || _load_sources()).Impl.create(name, compilerId, scope).src)
      });
      implVinylFile.test = false;

      return new Component({
        name,
        box,
        lang,
        bindingPrefix,
        version: (_constants || _load_constants()).LATEST_BIT_VERSION,
        scope: scopeName,
        specsFile,
        files: [implVinylFile],
        mainFile,
        compilerId,
        testerId,
        specs: withSpecs ? (_sources || _load_sources()).Specs.create(name, testerId, scope) : undefined
      });
    }
  }]);

  return Component;
}();

exports.default = Component;